*
* Inizializzazione AC01 per Low Pass Ellittic Filter
*

         .width   80
         .length  55
	 .title "AC01 Initialization Program"
         .mmregs

REG1	.set	18			; A Register (012h)
REG2	.set	36			; B Register (012h)
REG3	.set	00h			; A' Register (000h)
REG4	.set	09h			; Amplifier Gain-Select (005h)
REG5	.set	01h			; Analog Configuration (001h)
REG6	.set	00h			; Digital Configuration (000h)
REG7	.set	00h			; Frame-Sync Delay (000h)
REG8	.set	01h			; Fram-Sync number (001h)



AC01INIT:
	xf = 0				; reset ac01
	intm = 1			; disable all int service routines
	tcr = #10h                      ; stop timer
	imr = #280h			; wakeup from idle when TDM Xmt int
	tspc = #0008h			; stop TDM serial port
	tdxr = #0h			; send 0 as first xmit word
	tspc = #00c8h			; reset and start TDM serial port
	xf = 1				; release ac01 from reset

;	--------------- Register init's ------------------------------

	.if REG1 != 012h 		;
	a = #(REG1+0100h)		; load Acc A with REG1 value
	call REQ2			; Call REQ2 subroutine
	.endif

	.if REG2 != 012h
	a = #(REG2+0200h)
	call REQ2
	.endif

	.if REG3 != 000h
	a = #(REG3+0300h)
	call REQ2
	.endif

	.if REG4 != 005h
	a = #(REG4+0400h)
	call REQ2
	.endif

	.if REG5 != 001h
	a = #(REG5+0500h)
	call REQ2
	.endif

	.if REG6 != 000h
	a = #(REG6+0600h)
	call REQ2
	.endif

	.if REG7 != 000h
	a = #(REG7+0700h)
	call REQ2
	.endif

	.if REG8 != 001h
	a = #(REG8+0800h)
	call REQ2
	.endif
	return


REQ2
	ifr = #080h		      ; clear flag from IFR
	tdxr = #03h                   ; request secondary when AC01 starts

	idle(1) 		      ; wait for primary to xmit
	tdxr = a		      ; send register value to serial port
	ifr = #080h		      ; clear flag from IFR

	idle(1) 		      ; wait for secondary to xmit
	tdxr = #0h		      ; send neutral state in case last init
	ifr = #080h		      ; clear flag from IFR
	idle(1) 		      ; wait for neutral state to xmit
	return			      ; return from subroutine




