*
*   File name:   lpeflpt.asm
*
*   Description: filtro passa-basso ellittico realizzato in forma
*                parallela. Versione non real-time.
*                Specifiche di progetto:
*
*                   fp = 2 kHz     DBR < .5 dB
*                   fs = 3 kHz     Att < 40 dB
*
*   Last mofified: 03/06/98
*

	.title   "Low pass elliptic filter"
	.mmregs
	.width   80
	.length  60

	.setsect ".text",   1800h, 0
	.setsect ".data",   0200h, 1
	.setsect ".bss",    0210h, 1
	.setsect "vectors", 0180h, 0


	.sect "vectors"			; interrupt vector table stored at 
AC01_enable .set 0
	.copy "lpefvecs.asm"		; location 0x0180

	.sect ".data"

COEFF
	.word	-8417
	.word	24022
	.word	1735
	.word	-8526
	.word	23876
	.word	7519
	.word	-17633
	.word	-18729
	.word	16740
		; b11
		; a12
		; a11
		; b10
		; b21
		; a22
		; a21
		; b20
		; G
STATUS	.word	0			; W11
	.word	0			; W12
	.word	0			; W21
	.word	0			; W22


inbuf	.set 2000h
length	.set 020h
outbuf	.set 2400h


	.sect ".text"
start:

	intm = 1		; disable all interrupts
;	dcall AC01INIT		; initialize Analog interface.
	DP = #0
	nop
	pmst = #01a0h		; Interrupt pointer maps vectors to address 180h
	sp = #0ffah		; stack pointer located in Communications Kernal
	imr = #240h		; unmask TDM RINT and HPIINT(host port interface)
	intm = 0		; enable all interrupts
	FRCT = #1


	.asg AR1, in
	.asg AR2, out
	.asg AR3, coeff
	.asg AR4, status
	in = #inbuf
	out= #outbuf
	BK = #length
WAIT:
	coeff  = #COEFF
	status = #STATUS

inpp
	B = *in<<16			; y(n)=x(n)
	@BRC = #1			; due celle di 2o grado
	blockrepeat(end_cell)
start_cell
        B += *coeff * *status		; y(n)+=(bi1/2)*Wi1
        B += *coeff+ * *status+		; y(n)+=(bi1/2)*Wi1
	A = *in<<16			; yi=x(n)
	A -= *coeff+ * *status-		; yi-=ai2*Wi2
	A = rnd(A - *status * *coeff+)	; yi-=ai1*Wi1 (T=Wi1)
	*status+ = hi(A)		; Wi1=yi
	*status+ = T			; Wi2=T

	B += *coeff+ * hi(A)		; y(n)+=bi0*yi
end_cell

	A = B
	B = *coeff * hi(A)

outpp	*out+% = hi(B)
	goto WAIT

	.end

